<?php  
/**
 * CakePHP Patch: Extending CakePHP's CacheHelper to use Cache Engines
 * http://www.datumbox.com/
 *
 * Copyright 2013, Vasilis Vryniotis
 * Licensed under MIT or GPLv3, see LICENSE
 */
 
//In /app/Lib/Routing/Filter/MyCacheDispatcher.php we change the way that the cache is written
//============================================================================================
  
App::uses('CacheDispatcher', 'Routing/Filter');
App::uses('ClassRegistry', 'Utility');
  
class MyCacheDispatcher extends CacheDispatcher {
     
    public $priority = 8; //we place smaller priority than its parent to run this Dispatcher before its parent
     
    public function beforeDispatch(CakeEvent $event) {        
        //BELOW this point the code is the SAME as in CakePHP's method
        //============================================================
        if (Configure::read('Cache.check') !== true) {
            return;
        }
         
        $path = $event->data['request']->here();
        if ($path === '/') {
            $path = 'home';
        }
        $prefix = Configure::read('Cache.viewPrefix');
        if ($prefix) {
            $path = $prefix . '_' . $path;
        }
        $path = strtolower(Inflector::slug($path));
  
        $filename = CACHE . 'views' . DS . $path . '.php';
        //Up to this point the code is the SAME as in CakePHP's method
        //============================================================
           
        $cacheEngine='_cake_views_';
        $cacheKey = 'helper_cached_views_'.md5($filename);
        $data = Cache::read($cacheKey, $cacheEngine);
         
         
        if ($data) {
            $controller = null;
            App::import('View','My');
            $view = new MyView($controller);
            $result = $view->renderCacheFromString($data, microtime(true));
            if ($result !== false) {
                $event->stopPropagation();
                $event->data['response']->body($result);
                return $event->data['response'];
            }
        }
         
        return;
    }
}